%global debug_package %{nil}
%global git_sha 507c0de

Name:           etcd
Version:        3.5.17
Release:        1%{?dist}
Summary:        Distributed reliable key-value store for the most critical data of a distributed system
License:        Apache-2.0
URL:            https://github.com/etcd-io/etcd
Packager:       Teddysun <i@teddysun.com>
Source0:        https://github.com/etcd-io/etcd/archive/refs/tags/v%{version}.tar.gz#/%{name}-%{version}.tar.gz
Source1:        %{name}.service
Source2:        %{name}.conf

BuildRequires:  systemd-rpm-macros
Requires(pre):  shadow-utils
Requires:       glibc-common

# BuildRequires:  golang >= 1.22

%description
etcd is a distributed reliable key-value store for the most critical data of a distributed system, with a focus on being:
Simple: well-defined, user-facing API (gRPC)
Secure: automatic TLS with optional client cert authentication
Fast: benchmarked 10,000 writes/sec
Reliable: properly distributed using Raft

%prep
%setup -q -n %{name}-%{version}

mkdir -p ./bin

%build
# https://pagure.io/go-rpm-macros/c/1cc7f5d9026175bb6cb1b8c889355d0c4fc0e40a
%undefine _auto_set_build_flags

LDFLAGS="-X go.etcd.io/etcd/api/v3/version.GitSHA=%{git_sha} -s -w -buildid="

pushd ./server
env CGO_ENABLED=0 go build -v -trimpath -installsuffix=cgo -ldflags "${LDFLAGS}" -o ../bin/etcd .
popd
pushd ./etcdctl
env CGO_ENABLED=0 go build -v -trimpath -installsuffix=cgo -ldflags "${LDFLAGS}" -o ../bin/etcdctl .
popd
pushd ./etcdutl
env CGO_ENABLED=0 go build -v -trimpath -installsuffix=cgo -ldflags "${LDFLAGS}" -o ../bin/etcdutl .
popd

%install
%{__install} -d %{buildroot}%{_bindir}
%{__install} -p -m 755 ./bin/etcd %{buildroot}%{_bindir}
%{__install} -p -m 755 ./bin/etcdctl %{buildroot}%{_bindir}
%{__install} -p -m 755 ./bin/etcdutl %{buildroot}%{_bindir}
%{__install} -d %{buildroot}%{_unitdir}
%{__install} -p -m 644 %{SOURCE1} %{buildroot}%{_unitdir}/%{name}.service
%{__install} -d -m 755 %{buildroot}%{_sysconfdir}/%{name}
%{__install} -p -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/%{name}
# create /var/lib/etcd
%{__install} -d -m 755 %{buildroot}%{_sharedstatedir}/%{name}

%pre
getent group %{name} >/dev/null || groupadd -r %{name}
getent passwd %{name} >/dev/null || useradd -r -g %{name} -d %{_sharedstatedir}/%{name} \
    -s /sbin/nologin -c "etcd user" %{name}

%post
%systemd_post %{name}.service

%preun
%systemd_preun %{name}.service

%postun
%systemd_postun %{name}.service

%files
%license LICENSE
%doc CONTRIBUTING.md README.md
%doc Documentation
%{_bindir}/*
%dir %{_sysconfdir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/%{name}.conf
%{_unitdir}/%{name}.service
%dir %attr(-,%{name},%{name}) %{_sharedstatedir}/%{name}

%changelog
* Wed Nov 13 2024 Teddysun <i@teddysun.com> - 3.5.17-1
- Update to 3.5.17

* Thu Sep 12 2024 Teddysun <i@teddysun.com> - 3.5.16-1
- Update to 3.5.16
